apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ lemon_name }}
  name: {{ lemon_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ lemon_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ lemon_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ lemon_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ lemon_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ lemon_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ lemon_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if lemon_theme_repository_name is defined %}
{% if ((has_themes.resources | default([])) | length) > 0 %}
        - name: GIT_SSH_PORT
          value: "{{ lemon_theme_repository_ssh_port | default(22) }}"
        - name: LEMON_CUSTOM_THEMES
          value: git+ssh://{{ lemon_theme_repository_name }}
{% else %}
        - name: LEMON_CUSTOM_THEMES
          value: https://{{ lemon_theme_repository_name }}
{% endif %}
{% endif %}
        - name: LEMON_FCGID_CONNECT_TIMEOUT
          value: "{{ lemon_cgi_connect_timeout }}"
        - name: LEMON_FCGID_EXEC_TIMEOUT
          value: "{{ lemon_cgi_exec_timeout }}"
        - name: LLNG_APPNAME
          value: {{ lemon_appname }}
{% if matomo_api_public is defined %}
        - name: MATOMO_DOMAIN
          value: {{ matomo_api_public | urlsplit('hostname') }}
        - name: MATOMO_SITE_ID
          value: "{{ lemon_matomo_site_id }}"
{% endif %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=lemonldap,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: lemonldap-password
              name: {{ ldap_name }}
        - name: OPENLDAP_CONF_DN_PREFIX
          value: ou=lemonldap,ou=config
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
          value: {{ ldap_name }}
        - name: OPENLDAP_PORT
          value: "1636"
        - name: OPENLDAP_PROTO
          value: ldaps
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='lemon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='lemon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 15
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 8
        name: lemon
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ lemon_cpu_limit }}"
            memory: "{{ lemon_memory_limit }}"
          requests:
            cpu: "{{ lemon_cpu_request }}"
            memory: "{{ lemon_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/apache2/sites-enabled
          name: etcconf
          subPath: apache2
        - mountPath: /etc/lemonldap-ng
          name: etcconf
          subPath: lemon-main
        - mountPath: /usr/local/share/ca-certificates
          name: etcconf
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: etcconf
          subPath: empty
{% if lemon_theme_repository_name is defined and ((has_themes.resources | default([])) | length) > 0 %}
        - mountPath: /.ssh/id_rsa
          name: git-clone-ssh
          subPath: id_rsa
{% endif %}
      - args:
        - /job-lemonldap.sh
        command:
        - dumb-init
        env:
        - name: CLEANUP_PERIOD
          value: "21600"
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=lemonldap,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: lemonldap-password
              name: {{ ldap_name }}
        - name: OPENLDAP_CONF_DN_PREFIX
          value: ou=lemonldap,ou=config
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
          value: {{ ldap_name }}
        - name: OPENLDAP_PORT
          value: "1686"
        - name: OPENLDAP_PROTO
          value: ldaps
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='lemon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='lemon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: sessionsjob
        resources:
          limits:
            cpu: "{{ lemonjob_cpu_limit }}"
            memory: "{{ lemonjob_memory_limit }}"
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/lemonldap-ng
          name: etcconf
          subPath: lemon-job-sessions
      - args:
        - /watch-changes.sh
        command:
        - dumb-init
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=lemonldap,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: lemonldap-password
              name: {{ ldap_name }}
        - name: OPENLDAP_CONF_DN_PREFIX
          value: ou=lemonldap,ou=config
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
          value: {{ ldap_name }}
        - name: OPENLDAP_PORT
          value: "1636"
        - name: OPENLDAP_PROTO
          value: ldaps
        - name: RELOAD_INTERVAL
          value: "300"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='lemon'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='lemon'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: reloadjob
        resources:
          limits:
            cpu: "{{ lemonjob_cpu_limit }}"
            memory: "{{ lemonjob_memory_limit }}"
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /etc/lemonldap-ng
          name: etcconf
          subPath: lemon-job-reload
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
        securityContext:
          allowPrivilegeEscalation: false
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - auth.{{ root_domain }}
        - manager.{{ root_domain }}
        - reload.{{ root_domain }}
{% if do_exporters %}
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ lemon_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: etcconf
{% if lemon_theme_repository_name is defined and ((has_themes.resources | default([])) | length) > 0 %}
      - name: git-clone-ssh
        secret:
          mode: 420
          secretName: {{ lemon_theme_secret_name | default(lemon_name) }}
{% endif %}
      - configMap:
          name: {{ ldap_name }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if tls_provider == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='lemon'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - lemon
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='lemon'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - reloadjob
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='lemon'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sessionsjob
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='lemon'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
